//---------------------------------------------------------------------------

#ifndef ipropsH
#define ipropsH

#include <dsgnintf.hpp>
#include <qrexpred.hpp>
#include <QREnvEd.hpp>
//***************************************************************************
//***************************************************************************
class ITIFormDesigner : public IFormDesigner {
        private:
                int             FIndex;
                long            m_Count;
                TComponent*     root;
                TCustomForm*    mainForm;

                Controls::TWinControl* containerWnd;
                TDesignerSelectionList* selectionList;
        public:
                // IUnknown //
                virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid
                                        , void __RPC_FAR *__RPC_FAR *ppvObject);
                virtual ULONG STDMETHODCALLTYPE AddRef();
                virtual ULONG STDMETHODCALLTYPE Release();

                // IDesignerNotify //
	        virtual void __fastcall Modified();
	        virtual void __fastcall Notification(TPersistent* AnObject, TOperation Operation);

                // IDesigner //
	        virtual TCustomForm* __fastcall GetCustomForm();
	        virtual void __fastcall SetCustomForm(TCustomForm* Value);
	        virtual bool __fastcall GetIsControl();
	        virtual void __fastcall SetIsControl(bool Value);
	        virtual bool __fastcall IsDesignMsg(Controls::TControl* Sender, Messages::TMessage &Message);
        	virtual void __fastcall PaintGrid();
	        virtual void __fastcall ValidateRename(Classes::TComponent* AComponent, const AnsiString CurName, const
        		AnsiString NewName);
	        virtual AnsiString __fastcall UniqueName(const AnsiString BaseName);
        	virtual Classes::TComponent* __fastcall GetRoot();
	        __property bool IsControl = {read=GetIsControl, write=SetIsControl};
        	__property TCustomForm* Form = {read=GetCustomForm, write=SetCustomForm};


                // IFormDesigner //
	        virtual Sysutils::TMethod __fastcall CreateMethod(const AnsiString Name, Typinfo::PTypeData TypeData){throw Exception("    .");};
	        virtual AnsiString __fastcall GetMethodName(const Sysutils::TMethod &Method){throw Exception("    .");};
	        virtual void __fastcall GetMethods(Typinfo::PTypeData TypeData, Classes::TGetStrProc Proc){throw Exception("    .");};
	        virtual AnsiString __fastcall GetPrivateDirectory(void){throw Exception("   .");};
	        virtual void __fastcall GetSelections(const _di_IDesignerSelections List);
        	virtual bool __fastcall MethodExists(const AnsiString Name){throw Exception("    .");};
	        virtual void __fastcall RenameMethod(const AnsiString CurName, const AnsiString NewName){throw Exception("    .");};
        	virtual void __fastcall SelectComponent(Classes::TPersistent* Instance);
	        virtual void __fastcall SetSelections(const _di_IDesignerSelections List);
        	virtual void __fastcall ShowMethod(const AnsiString Name) {throw Exception("    .");};
	        virtual void __fastcall GetComponentNames(Typinfo::PTypeData TypeData, Classes::TGetStrProc Proc);
        	virtual Classes::TComponent* __fastcall GetComponent(const AnsiString Name);
	        virtual AnsiString __fastcall GetComponentName(Classes::TComponent* Component);
        	virtual Classes::TPersistent* __fastcall GetObject(const AnsiString Name);
	        virtual AnsiString __fastcall GetObjectName(Classes::TPersistent* Instance);
        	virtual void __fastcall GetObjectNames(Typinfo::PTypeData TypeData, Classes::TGetStrProc Proc);
	        virtual bool __fastcall MethodFromAncestor(const Sysutils::TMethod &Method){throw Exception("    .");};
        	virtual Classes::TComponent* __fastcall CreateComponent(TMetaClass* ComponentClass, Classes::TComponent*
	        	Parent, int Left, int Top, int Width, int Height);
        	virtual bool __fastcall IsComponentLinkable(Classes::TComponent* Component){throw Exception("    .");};
	        virtual void __fastcall MakeComponentLinkable(Classes::TComponent* Component){throw Exception("   .");};
        	virtual void __fastcall Revert(Classes::TPersistent* Instance, Typinfo::PPropInfo PropInfo){throw Exception("   .");};
	        virtual bool __fastcall GetIsDormant(void){throw Exception("   .");};
        	virtual bool __fastcall HasInterface(void){throw Exception("   .");};
	        virtual bool __fastcall HasInterfaceMember(const AnsiString Name){throw Exception("   .");};
        	virtual void __fastcall AddToInterface(int InvKind, const AnsiString Name, Word VT, const AnsiString TypeInfo){throw Exception("   .");};
        	virtual void __fastcall GetProjectModules(Classes::TGetModuleProc Proc){} ;
	        virtual _di_IFormDesigner __fastcall GetAncestorDesigner(void){throw Exception("   .");};
        	virtual bool __fastcall IsSourceReadOnly(void){throw Exception("   .");};
	        virtual Controls::TWinControl* __fastcall GetContainerWindow(void);
        	virtual void __fastcall SetContainerWindow(const Controls::TWinControl* NewContainer);
	        virtual Windows::TPoint __fastcall GetScrollRanges(const Windows::TPoint &ScrollPosition){throw Exception("   .");};
        	virtual void __fastcall Edit(const _di_IComponent Component){throw Exception("   .");};
	        virtual Menus::TPopupMenu* __fastcall BuildLocalMenu(Menus::TPopupMenu* Base, TLocalMenuFilters Filter){throw Exception("   .");};
	        virtual void __fastcall ChainCall(const AnsiString MethodName, const AnsiString InstanceName, const
        		AnsiString InstanceMethod, Typinfo::PTypeData TypeData){throw Exception("   .");};
	        virtual void __fastcall CopySelection(void){throw Exception("   .");};
        	virtual void __fastcall CutSelection(void){throw Exception("   .");};
	        virtual bool __fastcall CanPaste(void){throw Exception("   .");};
        	virtual void __fastcall PasteSelection(void){throw Exception("   .");};
	        virtual void __fastcall DeleteSelection(void){throw Exception("   .");};
        	virtual void __fastcall ClearSelection(void){throw Exception("   .");};
        	virtual void __fastcall NoSelection(void){throw Exception("   .");};
	        virtual void __fastcall ModuleFileNames(AnsiString &ImplFileName, AnsiString &IntfFileName, AnsiString
        		&FormFileName){throw Exception("   .");};
	        virtual AnsiString __fastcall GetRootClassName(void){throw Exception("   .");};
        	__property bool IsDormant = {read=GetIsDormant};
	        __property _di_IFormDesigner AncestorDesigner = {read=GetAncestorDesigner};
        	__property Controls::TWinControl* ContainerWindow = {read=GetContainerWindow, write=SetContainerWindow};

                ITIFormDesigner(Controls::TWinControl* NewContainer);
                ~ITIFormDesigner();

};
//***************************************************************************
class TIQREexprProperty : public TStringProperty {
        public:
                void __fastcall Edit();
                TPropertyAttributes __fastcall GetAttributes();

                inline __fastcall TIQREexprProperty(const _di_IFormDesigner ADesigner
		                        , int APropCount) : TStringProperty(ADesigner, APropCount) { };
};

//***************************************************************************
class TIQREnvProperty : public TClassProperty {
        public:
                void __fastcall Edit();
                TPropertyAttributes __fastcall GetAttributes();

                inline __fastcall TIQREnvProperty(const _di_IFormDesigner ADesigner
		                        , int APropCount) : TClassProperty(ADesigner, APropCount) { };
};

//***************************************************************************
class TIStringsProperty : public TClassProperty {
        public:
                void __fastcall Edit();
                TPropertyAttributes __fastcall GetAttributes();

                inline __fastcall TIStringsProperty(const _di_IFormDesigner ADesigner
		                        , int APropCount) : TClassProperty(ADesigner, APropCount) { };
};
//***************************************************************************
#endif
